<template>
  <div class="drawer_info">
    <div class="drawer_title">{{ dataForm.id ? "修改" : "新增" }}</div>
    <el-form
      :model="dataForm"
      :rules="dataRule"
      ref="dataForm"
      @keyup.enter.native="dataFormSubmitHandle()"
      class="drawer_list"
    >
      <el-form-item prop="parentName" label="上级区域">
        <ren-region-tree
          v-model="dataForm.pid"
          placeholder="选择区域"
          :parent-name.sync="dataForm.parentName"
        ></ren-region-tree>
      </el-form-item>
      <el-form-item prop="name" :label="$t('region.name')">
        <el-input
          v-model="dataForm.name"
          :placeholder="$t('region.name')"
        ></el-input>
      </el-form-item>
      <el-form-item prop="id" :label="$t('region.id')">
        <el-input
          v-model="dataForm.id"
          :disabled="!insert"
          :placeholder="$t('region.id')"
        ></el-input>
      </el-form-item>
      <el-form-item prop="sort" :label="$t('region.sort')">
        <el-input-number
          v-model="dataForm.sort"
          controls-position="right"
          :min="0"
          :label="$t('region.sort')"
        ></el-input-number>
      </el-form-item>
    </el-form>
    <div class="save_btn">
      <el-button type="primary" @click="dataFormSubmitHandle()">{{
        $t("confirm")
      }}</el-button>
      <el-button plain @click="resetForm('dataForm')">重置</el-button>
    </div>
  </div>
</template>

<script>
import debounce from "lodash/debounce";
export default {
  data() {
    return {
      insert: true,
      regionList: [],
      regionListVisible: false,
      dataForm: {
        id: "",
        name: "",
        pid: "0",
        parentName: "",
        sort: 0,
      },
      id: "",
    };
  },
  computed: {
    dataRule() {
      return {
        id: [
          {
            required: true,
            message: this.$t("validate.required"),
            trigger: "blur",
          },
        ],
        name: [
          {
            required: true,
            message: this.$t("validate.required"),
            trigger: "blur",
          },
        ],
        sort: [
          {
            required: true,
            message: this.$t("validate.required"),
            trigger: "blur",
          },
        ],
      };
    },
  },
  methods: {
    init() {
      this.insert = true;
      this.dataForm.pid = "0";
      this.$nextTick(() => {
        this.$refs["dataForm"].resetFields();
        if (this.id) {
          this.insert = false;
          this.getInfo();
        }
      });
    },
    resetForm(formName) {
      this.$refs[formName].resetFields();
      console.log(this.dataForm);
    },
    // 获取信息
    getInfo() {
      this.$http
        .get(`/sys/region/${this.id}`)
        .then(({ data: res }) => {
          if (res.code !== 0) {
            return this.$message.error(res.msg);
          }
          this.dataForm = {
            ...this.dataForm,
            ...res.data,
          };
          this.$refs.regionListTree.setCurrentKey(this.dataForm.pid);
        })
        .catch(() => {});
    },
    // 表单提交
    dataFormSubmitHandle: debounce(
      function () {
        this.$refs["dataForm"].validate((valid) => {
          if (!valid) {
            return false;
          }
          this.$http[this.insert ? "post" : "put"]("/sys/region", this.dataForm)
            .then(({ data: res }) => {
              if (res.code !== 0) {
                return this.$message.error(res.msg);
              }
              this.$message({
                message: this.$t("prompt.success"),
                type: "success",
                duration: 500,
                onClose: () => {
                  this.$emit("refreshDataList");
                },
              });
            })
            .catch(() => {});
        });
      },
      1000,
      { leading: true, trailing: false }
    ),
  },
};
</script>

<style lang="scss">
.customWidth.alert {
  width: 50%;
  .el-dialog__title {
    border-left: 4px solid #ddd;
    padding-left: 8px;
    border-color: #5776e6;
  }
}
.mod-sys__region {
  .region-list {
    .el-input__inner,
    .el-input__suffix {
      cursor: pointer;
    }
  }
}
</style>
